<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des situations familiales n'ont pas pu être chargées."
    />
    <template v-else-if="familySituationsCounts">
      <h2 class="fr-h5">Types de situations familiales</h2>
      <StatsList
        v-if="familySituationsCounts.length"
        :total-count="beneficiaryCount"
        :stats="familySituationsCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des situations
        familiales.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { FAMILY_SITUATION_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: familySituationsCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('familySituationsCounts', loadFamilySituationsCounts, {
    server: false,
    default: () => 0
  })

  watch(() => props.filters, refresh)

  async function loadFamilySituationsCounts() {
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems('beneficiary', {
      groupBy: 'family_situation',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const familySituationsResCounts = res.data.data.map(situation => ({
        key: situation.family_situation,
        label: labelOrUnprovided(
          situation.family_situation,
          FAMILY_SITUATION_OPTIONS
        ),
        count: parseInt(situation.countDistinct.id)
      }))
      familySituationsResCounts.sort((a, b) => b.count - a.count)
      return familySituationsResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
